package com.rp.util.sort;

import com.rp.util.sort.ISort;
import com.rp.util.sort.SortException;
import com.rp.util.ReflectionUtil;
import java.util.Comparator;
import java.util.List;

public final class QuickSortMedian3 implements ISort
{
	public QuickSortMedian3 ()
	{}
	
	public void sort (int[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (int[] arr, int begin, int end)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			int middle = getMedian (arr, begin, end);
			int temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	protected int getMedian (int[] arr, int low, int high)
	{            
		int middle = ( low + high ) / 2;
		if (arr[middle] < arr[low])  
		{
			int temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (arr[high] < arr[low])
		{
			int temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (arr[high] < arr[middle])
		{
			int temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}
	
	public void sort (String[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (String[] arr, int begin, int end)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			String middle = getMedian (arr, begin, end);
			String temp;
			while (low <= high)
			{
				while (low < end && arr[low].compareToIgnoreCase(middle) < 0)
				{
					low++;
				}
				while (high > begin && arr[high].compareToIgnoreCase(middle) > 0)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	protected String getMedian (String[] arr, int low, int high)
	{            
		int middle = ( low + high ) / 2;
		if (arr[middle].compareToIgnoreCase(arr[low]) < 0)  
		{
			String temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (arr[high].compareToIgnoreCase(arr[low]) < 0)
		{
			String temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (arr[high].compareToIgnoreCase(arr[middle]) < 0)
		{
			String temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}
	
	public void sort (long[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (long[] arr, int begin, int end)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			long middle = getMedian (arr, begin, end);
			long temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	protected long getMedian (long[] arr, int low, int high)
	{            
		int middle = ( low + high ) / 2;
		if (arr[middle] < arr[low])  
		{
			long temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (arr[high] < arr[low])
		{
			long temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (arr[high] < arr[middle])
		{
			long temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}
	
	public void sort (short[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (short[] arr, int begin, int end)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			short middle = getMedian (arr, begin, end);
			short temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	protected short getMedian (short[] arr, int low, int high)
	{            
		int middle = ( low + high ) / 2;
		if (arr[middle] < arr[low])  
		{
			short temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (arr[high] < arr[low])
		{
			short temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (arr[high] < arr[middle])
		{
			short temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}
	

	public void sort (double[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (double[] arr, int begin, int end)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			double middle = getMedian (arr, begin, end);
			double temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}
	
	protected double getMedian (double[] arr, int low, int high)
	{            
		int middle = ( low + high ) / 2;
		if (arr[middle] < arr[low])  
		{
			double temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (arr[high] < arr[low])
		{
			double temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (arr[high] < arr[middle])
		{
			double temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}
	

	public void sort (float[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (float[] arr, int begin, int end)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			float middle = getMedian (arr, begin, end);
			float temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}
	
	protected float getMedian (float[] arr, int low, int high)
	{            
		int middle = ( low + high ) / 2;
		if (arr[middle] < arr[low])  
		{
			float temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (arr[high] < arr[low])
		{
			float temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (arr[high] < arr[middle])
		{
			float temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}
	

	public void sort (char[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (char[] arr, int begin, int end)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			char middle = getMedian (arr, begin, end);
			char temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	protected char getMedian (char[] arr, int low, int high)
	{            
		int middle = ( low + high ) / 2;
		if (arr[middle] < arr[low])  
		{
			char temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (arr[high] < arr[low])
		{
			char temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (arr[high] < arr[middle])
		{
			char temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}
	
	public void sort (byte[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (byte[] arr, int begin, int end)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			byte middle = getMedian (arr, begin, end);
			byte temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}
	
	protected byte getMedian (byte[] arr, int low, int high)
	{            
		int middle = ( low + high ) / 2;
		if (arr[middle] < arr[low])  
		{
			byte temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (arr[high] < arr[low])
		{
			byte temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;	
		}          
		if (arr[high] < arr[middle])
		{
			byte temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}
	

	public void sort (Object[] arr, Comparator c, String methodName) throws SortException
	{
		sort (arr, c, methodName, new Class[0], new Object[0]);	
	}
	
	public void sort (Object[] arr, Comparator c, String methodName, Class[] paramTypes, Object[] paramValues)
						 throws SortException
	{
		sort (arr, 0, arr.length-1, c, methodName, paramTypes, paramValues);
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName) 
							throws SortException
	{
		sort (arr, begin, end, c, methodName, new Class[0], new Object[0]);
	}

	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName, Class[] paramTypes,
								Object[] paramValues) throws SortException
	{
		try
		{
			if (end > begin)
			{
				int low = begin;
				int high = end;
				Object middle = getMedian (arr, begin, end, c, methodName, paramTypes, paramValues);
				Object temp;
				while (low <= high)
				{
					while (low < end && c.compare(ReflectionUtil.getMethodValue(arr[low], methodName, paramTypes, paramValues),
							 middle) < 0)
					{
						low++;
					}
					while (high > begin && c.compare(ReflectionUtil.getMethodValue (arr[high], methodName, paramTypes, paramValues), 
							 middle) > 0)
					{
						high--;	
					}
					if (low <= high)
					{
						temp = arr[low];
						arr[low] = arr[high];
						arr[high] = temp;
						low++;
						high--;	
					}
				}
				if (begin < high)
				{
					sort (arr, begin, high, c, methodName, paramTypes, paramValues);	
				}
				if (low < end)
				{
					sort (arr, low, end, c, methodName, paramTypes, paramValues);
				}
			}
		}
		catch (Exception e)
		{
			throw new SortException (e);	
		}
	}
	
	protected Object getMedian (Object[] arr, int low, int high, Comparator c, String methodName, 
								Class[] paramTypes, Object[] paramValues) throws Exception
	{            
		int middle = ( low + high ) / 2;
		if (c.compare(ReflectionUtil.getMethodValue(arr[middle], methodName, paramTypes, paramValues),
					  ReflectionUtil.getMethodValue(arr[low], methodName, paramTypes, paramValues)) < 0)
		{
			Object temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (c.compare(ReflectionUtil.getMethodValue(arr[high], methodName, paramTypes, paramValues),
					  ReflectionUtil.getMethodValue(arr[low], methodName, paramTypes, paramValues)) < 0)
		{
			Object temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (c.compare(ReflectionUtil.getMethodValue(arr[high], methodName, paramTypes, paramValues),
					  ReflectionUtil.getMethodValue(arr[middle], methodName, paramTypes, paramValues)) < 0)
		{
			Object temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return ReflectionUtil.getMethodValue(arr[middle], methodName, paramTypes, paramValues);
	}
	
	
	public void sort (Object[] arr, Comparator c)
	{
		sort (arr, 0, arr.length-1, c);
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			Object middle = getMedian (arr, begin, end, c);
			Object temp;
			while (low <= high)
			{
				while (low < end && c.compare(arr[low], middle) < 0)
				{
					low++;
				}
				while (high > begin && c.compare(arr[high], middle) > 0)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high, c);	
			}
			if (low < end)
			{
				sort (arr, low, end, c);
			}
		}
	}
	
	public void sort (List arr, Comparator c)
	{
		sort (arr, 0, arr.size()-1, c);
	}
	
	public void sort (List arr, int begin, int end, Comparator c)
	{
		if (end > begin)
		{
			int low = begin;
			int high = end;
			Object middle = getMedian (arr, begin, end, c);
			Object temp;
			while (low <= high)
			{
				while (low < end && c.compare(arr.get(low), middle) < 0)
				{
					low++;
				}
				while (high > begin && c.compare(arr.get(high), middle) > 0)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr.get(low);
					arr.set(low, arr.get(high));
					arr.set(high, temp);
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high, c);	
			}
			if (low < end)
			{
				sort (arr, low, end, c);
			}
		}
	}
	
	protected Object getMedian (Object[] arr, int low, int high, Comparator c)
	{            
		int middle = ( low + high ) / 2;
		if (c.compare(arr[middle], arr[low]) < 0)
		{
			Object temp = arr[low];
			arr[low] = arr[middle];
			arr[middle] = temp;
		}
		if (c.compare(arr[high], arr[low]) < 0)
		{
			Object temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
		}          
		if (c.compare(arr[high], arr[middle]) < 0)
		{
			Object temp = arr[middle];
			arr[middle] = arr[high];
			arr[high] = temp;
		}    
		return arr[middle];
	}	
	
	protected Object getMedian (List arr, int low, int high, Comparator c)
	{            
		int middle = ( low + high ) / 2;
		if (c.compare(arr.get(middle), arr.get(low)) < 0)
		{
			Object temp = arr.get(low);;
			arr.set(low, arr.get(middle));
			arr.set(middle, temp);
		}
		if (c.compare(arr.get(high), arr.get(low)) < 0)
		{
			Object temp = arr.get(low);
			arr.set(low, arr.get(high));
			arr.set(high, temp);
		}          
		if (c.compare(arr.get(high), arr.get(middle)) < 0)
		{
			Object temp = arr.get(middle);
			arr.set(middle, arr.get(high));
			arr.set(high, temp);
		}    
		return arr.get(middle);
	}	
}