package com.rp.util.test;

import java.util.Random;

public class RandomArrayGenerator
{
	public static Random random = new Random();
	public static int RSIZE = 1000;
	
	public static int[] getInt (int length)
	{
		int[] arr = new int[length];
		for (int i = 0; i < length; i++)
		{
			arr[i] = random.nextInt(RSIZE);
		}	
		return arr;
	}
	
	public static long[] getLong (int length)
	{
		long[] arr = new long[length];
		for (int i = 0; i < length; i++)
		{
			double d = random.nextDouble();
			d = d * RSIZE;
			arr[i] = (long)d;
		}	
		return arr;
	}
	
	
	public static short[] getShort (int length)
	{
		short[] arr = new short[length];
		for (int i = 0; i < length; i++)
		{
			arr[i] = (short)random.nextInt(RSIZE);
		}	
		return arr;
	}
	
	public static double[] getDouble (int length)
	{
		double[] arr = new double[length];
		for (int i = 0; i < length; i++)
		{
			double d = random.nextDouble();
			d = d * RSIZE;
			arr[i] = (double)d;
		}	
		return arr;
	}
	
	public static float[] getFloat (int length)
	{
		float[] arr = new float[length];
		for (int i = 0; i < length; i++)
		{
			double d = random.nextDouble();
			d = d * RSIZE;
			arr[i] = (float)d;
		}	
		return arr;
	}
	
	public static String[] getString(int length, int wordSize)
	{
		String[] arr = new String[length];
		for (int i = 0; i < length; i++)
		{
			String s = "";
			char[] c = getChar(wordSize);
			for (int x = 0; x < c.length; x++)
			{
				s = s + c[x];
			}
			arr[i] = s;
		}	
		return arr;
	}
	
	public static char[] getChar (int length)
	{
		char[] arr = new char[length];
		for (int i = 0; i < length; i++)
		{
			int val = random.nextInt(51);
			switch (val)
			{
				case 0:
					arr[i] = 'A';
					break;
				case 1:
					arr[i] = 'a';
					break;
				case 2:
					arr[i] = 'B';
					break;
				case 3:
					arr[i] = 'b';
					break;
				case 4:
					arr[i] = 'C';
					break;
				case 5:
					arr[i] = 'c';
					break;
				case 6:
					arr[i] = 'D';
					break;
				case 7:
					arr[i] = 'd';
					break;
				case 8:
					arr[i] = 'E';
					break;
				case 9:
					arr[i] = 'e';
					break;
				case 10:
					arr[i] = 'F';
					break;
				case 11:
					arr[i] = 'f';
					break;
				case 12:
					arr[i] = 'H';
					break;
				case 13:
					arr[i] = 'h';
					break;
				case 14:
					arr[i] = 'I';
					break;
				case 15:
					arr[i] = 'i';
					break;
				case 16:
					arr[i] = 'J';
					break;
				case 17:
					arr[i] = 'j';
					break;
				case 18:
					arr[i] = 'K';
					break;
				case 19:
					arr[i] = 'k';
					break;
				case 20:
					arr[i] = 'L';
					break;
				case 21:
					arr[i] = 'l';
					break;
				case 22:
					arr[i] = 'M';
					break;
				case 23:
					arr[i] = 'm';
					break;
				case 24:
					arr[i] = 'O';
					break;
				case 25:
					arr[i] = 'o';
					break;
				case 26:
					arr[i] = 'P';
					break;
				case 27:
					arr[i] = 'p';
					break;
				case 28:
					arr[i] = 'G';
					break;
				case 29:
					arr[i] = 'g';
					break;
				case 30:
					arr[i] = 'Q';
					break;	
				case 31:
					arr[i] = 'q';
					break;
				case 32:
					arr[i] = 'R';
					break;
				case 33:
					arr[i] = 'r';
					break;
				case 34:
					arr[i] = 'S';
					break;
				case 35:
					arr[i] = 's';
					break;
				case 36:
					arr[i] = 'T';
					break;
				case 37:
					arr[i] = 't';
					break;
				case 38:
					arr[i] = 'U';
					break;	
				case 39:
					arr[i] = 'u';
					break;
				case 40:
					arr[i] = 'V';
					break;
				case 41:
					arr[i] = 'v';
					break;
				case 42:
					arr[i] = 'W';
					break;
				case 43:
					arr[i] = 'w';
					break;
				case 44:
					arr[i] = 'X';
					break;
				case 45:
					arr[i] = 'x';
					break;
				case 46:
					arr[i] = 'Y';
					break;
				case 47:
					arr[i] = 'y';
					break;	
				case 48:
					arr[i] = 'Z';
					break;
				case 49:
					arr[i] = 'z';
					break;
				case 50:
					arr[i] = 'N';
					break;
				case 51:
					arr[i] = 'n';
					break;
			}
		}	
		return arr;
	}	
	
	public static byte[] getByte (int length)
	{
		byte[] arr = new byte[length];
		for (int i = 0; i < length; i++)
		{
			char[] c = getChar(1);
			arr[i] = (byte)c[0];
		}
		return arr;	
	}
	
}