package test.sort;

import test.sort.SortTest;
import test.sort.IObject;
import test.sort.IObjectCompare;
import test.util.ArrayPrint;
import com.rp.util.test.RandomArrayGenerator;
import com.rp.util.sort.*;
import com.rp.util.sort.compare.IntegerComparator;

public class SortTester
{
	
	public static void main (String[] args)
	{
		if (args.length != 3)
		{
			System.out.println ("USAGE: ARRAY_SIZE TYPE ");
			System.out.println ("EXAMPLE: java test/sort/SortTester 100 int HeapSort");
			System.out.println ("SORT TYPES:");
			System.out.println ("InsertionSort, InsertionSortBinarySearch, MergeSort, MergeInsertionSort, ");
			System.out.println ("QuickSort, QuickInsertionSort, QuickSortMedian3, QuickSortRandom, ");
			System.out.println ("HeapSort, BubbleSort, ShellSort, CombSort");
			System.exit(0);	
		}
		
		int count = (new Integer(args[0])).intValue();
		String type = args[1];
		String sortType = args[2];
		
		SortTest sTest = null;
		
		if (sortType.equals ("InsertionSort"))
		{
			sTest = new SortTest(new InsertionSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("InsertionSortBinarySearch"))
		{
			sTest = new SortTest(new InsertionSortBinarySearch());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("MergeSort"))
		{
			sTest = new SortTest(new MergeSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("MergeInsertionSort"))
		{
			sTest = new SortTest(new MergeInsertionSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals("QuickSort"))
		{
			sTest = new SortTest(new QuickSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("QuickInsertionSort"))
		{
			sTest = new SortTest(new QuickInsertionSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("QuickSortMedian3"))
		{
			sTest = new SortTest(new QuickSortMedian3());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("QuickSortRandom"))
		{
			sTest = new SortTest(new QuickSortRandom());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("HeapSort"))
		{
			sTest = new SortTest(new HeapSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("SelectionSort"))
		{
			sTest = new SortTest(new SelectionSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("BubbleSort"))
		{
			sTest = new SortTest(new BubbleSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("ShellSort"))
		{
			sTest = new SortTest(new ShellSort());
			sTest.sort(type, count);
		}
		
		if (sortType.equals ("CombSort"))
		{
			sTest = new SortTest(new CombSort());
			sTest.sort(type, count);
		}
	}
}